
/******************************************************************************
 *
 *  Quest Software, Inc.
 * ALL RIGHTS RESERVED.
 *
 * Redistribution and use in source and binary forms, with or without modification, 
 * are permitted provided that the following conditions are met:
 * 
 *  *  Redistributions of source code must retain the above copyright notice, 
 *     this list of conditions and the following disclaimer.  
 * 
 *  *  Redistributions in binary form must reproduce the above copyright notice, 
 *     this list of conditions and the following disclaimer in the documentation 
 *     and/or other materials provided with the distribution.  
 * 
 *  *  Neither the name of Quest Software, Inc. nor the names of its contributors 
 *     may be used to endorse or promote products derived from this software 
 *     without specific prior written permission. 
 * 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ON AN "AS IS" 
 * AND UNSUPPORTED BASIS, WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES OF ANY KIND, 
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, NON-
 * INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT SHALL THE COPYRIGHT 
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 ************************************************************************************/


#include "userExperiencePage.h"

enum {
    ConnectionSpeedIndexModem28,
    ConnectionSpeedIndexModem56,
    ConnectionSpeedIndexBroadband,
    ConnectionSpeedIndexLan,
    ConnectionSpeedIndexCustom
};

UserExperiencePage::UserExperiencePage(Farm *farm, ManageConnectionDialog *parent)
    : ManageConnectionPage(farm, parent)
{
	setupUi(this);

//	connect(connectionSpeedComboBox, SIGNAL(currentIndexChanged(int)),
//			this, SLOT(modemSpeedSelected(int)));
}

UserExperiencePage::~UserExperiencePage()
{

}

void UserExperiencePage::modemSpeedSelected(int index)
{
	// Uncheck all boxes
	if (index != connectionSpeedComboBox->count()-1)
	{
//		backgroundCheckBox->setChecked(false);
//		showWhileDraggingCheckBox->setChecked(false);
//		animationCheckBox->setChecked(false);
//		themesCheckBox->setChecked(false);
		bitmapCachingCheckBox->setChecked(false);
		mmrEnableCheckBox->setChecked(false);
		fmmrEnableCheckBox->setChecked(false);
		gaEnableCheckBox->setChecked(false);
	}

	// Checking use switch feature
	switch (index)
	{
	case 3 :
//		backgroundCheckBox->setChecked(true);
//		showWhileDraggingCheckBox->setChecked(true);
	case 2 :
//		animationCheckBox->setChecked(true);
	case 1 :
//		themesCheckBox->setChecked(true);
	case 0 :
		bitmapCachingCheckBox->setChecked(true);
	}
}

void UserExperiencePage::saveFarmSettings()
{
        if (currentFarm == 0)
		return;

    currentFarm->setWallpaperEnable(connectionSpeedComboBox->currentIndex() > ConnectionSpeedIndexLan);
    currentFarm->setDraggingEnable(connectionSpeedComboBox->currentIndex() > ConnectionSpeedIndexBroadband);
    currentFarm->setAnimationEnable(connectionSpeedComboBox->currentIndex() > ConnectionSpeedIndexModem56);
    currentFarm->setThemesEnable(connectionSpeedComboBox->currentIndex() > ConnectionSpeedIndexModem28);

        currentFarm->setBitmapCachingEnable(bitmapCachingCheckBox->isChecked());
        currentFarm->setMmrEnable(mmrEnableCheckBox->isChecked());
        currentFarm->setFmmrEnable(fmmrEnableCheckBox->isChecked());
	currentFarm->setGaEnable(gaEnableCheckBox->isChecked());
        //currentFarm->setReconnection(reconnectDroppedCheckBox->isChecked());
}

void UserExperiencePage::loadFarmSettings()
{
	// Farm doesn`t existing
        if (currentFarm == 0)
		return;

	if (currentFarm->isWallpaperEnabled())
        connectionSpeedComboBox->setCurrentIndex(ConnectionSpeedIndexCustom);
	else if (currentFarm->isDraggingEnabled())
        connectionSpeedComboBox->setCurrentIndex(ConnectionSpeedIndexLan);
	else if (currentFarm->isAnimationEnabled())
        connectionSpeedComboBox->setCurrentIndex(ConnectionSpeedIndexBroadband);
    else if (currentFarm->isThemesEnabled())
        connectionSpeedComboBox->setCurrentIndex(ConnectionSpeedIndexModem56);
    else
        connectionSpeedComboBox->setCurrentIndex(ConnectionSpeedIndexModem28);

//        backgroundCheckBox->setChecked(currentFarm->isWallpaperEnabled());
//        showWhileDraggingCheckBox->setChecked(currentFarm->isDraggingEnabled());
//        animationCheckBox->setChecked(currentFarm->isAnimationEnabled());
//        themesCheckBox->setChecked(currentFarm->isThemesEnabled());
        bitmapCachingCheckBox->setChecked(currentFarm->isBitmapCachingEnabled());
        mmrEnableCheckBox->setChecked(currentFarm->isMmrEnabled());
        fmmrEnableCheckBox->setChecked(currentFarm->isFmmrEnabled());
        gaEnableCheckBox->setChecked(currentFarm->isGaEnabled());
//        reconnectDroppedCheckBox->setChecked(currentFarm->isReconnection());
}
