
/******************************************************************************
 *
 *  Quest Software, Inc.
 * ALL RIGHTS RESERVED.
 *
 * Redistribution and use in source and binary forms, with or without modification, 
 * are permitted provided that the following conditions are met:
 * 
 *  *  Redistributions of source code must retain the above copyright notice, 
 *     this list of conditions and the following disclaimer.  
 * 
 *  *  Redistributions in binary form must reproduce the above copyright notice, 
 *     this list of conditions and the following disclaimer in the documentation 
 *     and/or other materials provided with the distribution.  
 * 
 *  *  Neither the name of Quest Software, Inc. nor the names of its contributors 
 *     may be used to endorse or promote products derived from this software 
 *     without specific prior written permission. 
 * 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ON AN "AS IS" 
 * AND UNSUPPORTED BASIS, WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES OF ANY KIND, 
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, NON-
 * INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT SHALL THE COPYRIGHT 
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 ************************************************************************************/


#ifndef MANAGECONNECTIONDIALOG_H
#define MANAGECONNECTIONDIALOG_H

#include <QtGui/QDialog>
#include <QStackedWidget>
#include "ui_manageConnectionDialog.h"
#include "../farmSettings.h"

class ManageConnectionDialog : public QDialog,
	private Ui::ManageConnectionDialogClass
{
    Q_OBJECT

public:
    ManageConnectionDialog(FarmSettings *settings, bool wizardMode,
                           const QString & actuallyFarmName, QWidget *parent = 0);
    ~ManageConnectionDialog();

    void addPage(QWidget *page);


    void saveFarmSettings();

    FarmSettings * getFarmSettings() { return farmSettings; };

    void setDialogMode(bool);
    void setDialogFarm(bool wizardMode, const QString & name = "");

public slots:

        void loadFarmSettings();
        void updateFarmName(QString name);

private slots:
	void accept();
	void back();
	void cancel();
	void next();

	void currentPageChanged(int);

private:
        void createConnectionDialog();
        bool isFarmLocationsCorrect(Farm* farm);

        FarmSettings *farmSettings;
        Farm *currentFarm;

        QString p_currentFarmName;
        bool p_isWizardMode;
};

#endif // MANAGECONNECTIONDIALOG_H
