
/******************************************************************************
 *
 *  Quest Software, Inc.
 * ALL RIGHTS RESERVED.
 *
 * Redistribution and use in source and binary forms, with or without modification, 
 * are permitted provided that the following conditions are met:
 * 
 *  *  Redistributions of source code must retain the above copyright notice, 
 *     this list of conditions and the following disclaimer.  
 * 
 *  *  Redistributions in binary form must reproduce the above copyright notice, 
 *     this list of conditions and the following disclaimer in the documentation 
 *     and/or other materials provided with the distribution.  
 * 
 *  *  Neither the name of Quest Software, Inc. nor the names of its contributors 
 *     may be used to endorse or promote products derived from this software 
 *     without specific prior written permission. 
 * 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ON AN "AS IS" 
 * AND UNSUPPORTED BASIS, WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES OF ANY KIND, 
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, NON-
 * INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT SHALL THE COPYRIGHT 
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 ************************************************************************************/


/*
 *
 * Copyright (C) 2007-2009 SimplyCore LLC
 * All rights reserved.
 * This file is part of Linux USB IP project.
 * Distributed under Non-disclosure agreement.
 *
 */

/* Public network definition */

#ifndef _PUBNET_
#define _PUBNET_

#define usbsignature		0x54425355	// USBT
#define controlconn		0x4C525443	// CTRL

#define cInitpacket			0x01
#define cInfopacket			0x02
#define cDatapacket			0x03
#define cPingpacket			0x04
#define cRemovepacket		0x05
#define cCallbackpacket		0x06
#define cSethandlepacket	0x07
#define cConnectRequest		0x08
#define cDisconnectRequest	0x09

#define cConnectionAccept	0x10
#define cConnectionRegect	0x11

#define cPlatformOk			0x20
#define cInvalidPlatform	0x21
#define cOldPlatform		0x22
#define cRecvError			0x2a
#define cSendError			0x2b
#define cVersionIncorect	0x2c

#define cTargetAcquire		0x30
#define cTargetBusy			0x31
#define cSyncError			0x32
#define cTargetNotFound		0x33
#define cTargetNotReady		0x34
#define cTargetUnplug		0x35
#define cTargetConnected	0x36 
#define cBadClient			0x37 
#define cClientAccept		0x38 
#define cClientRegect		0x39
#define cNetworkLicenseExc	0x3a
#define cWaitDisconnect		0x3b
#define cProtocolBroken		0x3c
#define cServerLicenseExc	0x40
#define cCryptoKeyBroken	0x41
#define cTrialExpired		0x42

#define cCreateConnection					0x43
#define cCompleteConnection					0x44
#define cCreateInfoChanel					0x45
#define cCreateCallBackInfoChanel			0x46
#define cCreateCallBackConnection			0x47
#define cCreateCallBackCompleteConnection	0x48

#define windows_2k			0x50
#define windows_xp			0x51
#define windows_2k3			0x52
#define windows_vista		0x53

#define windows_xp_64		0x70
#define windows_2k3_64		0x71
#define windows_vista_64	0x72

#define linux_32		0x90
#define linux_be		0x91

#define PingInterval				10 // sec
#define DoPingInterval	(PingInterval * 2)
#define PinggedInterval	(PingInterval * 3)

#endif //_PUBNET_
