
/******************************************************************************
 *
 *  Quest Software, Inc.
 * ALL RIGHTS RESERVED.
 *
 * Redistribution and use in source and binary forms, with or without modification, 
 * are permitted provided that the following conditions are met:
 * 
 *  *  Redistributions of source code must retain the above copyright notice, 
 *     this list of conditions and the following disclaimer.  
 * 
 *  *  Redistributions in binary form must reproduce the above copyright notice, 
 *     this list of conditions and the following disclaimer in the documentation 
 *     and/or other materials provided with the distribution.  
 * 
 *  *  Neither the name of Quest Software, Inc. nor the names of its contributors 
 *     may be used to endorse or promote products derived from this software 
 *     without specific prior written permission. 
 * 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ON AN "AS IS" 
 * AND UNSUPPORTED BASIS, WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES OF ANY KIND, 
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, NON-
 * INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT SHALL THE COPYRIGHT 
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 ************************************************************************************/


/*
 *
 * Copyright (C) 2007-2009 SimplyCore LLC
 * All rights reserved.
 * This file is part of Linux USB IP project.
 * Distributed under Non-disclosure agreement.
 *
 */

/* Public network USB protocol definition */

#ifndef _PUBNETPROTOCOL_
#define _PUBNETPROTOCOL_

#pragma pack (push, 1)

typedef struct _nethwid {
	uint16 idVendor;
	uint16 idProduct;
	uint16 bcdDevice;
} __attribute__((packed)) nethwid, *pnethwid;

typedef struct _tagnetheader {
	uint32	ntype;
	uint32	ndatasize;	//    
} __attribute__((packed)) netheader, *pnetheader;

typedef struct _netiface {
	uint8 devclass;
	uint8 devsubclass;
	uint8 devprotocol;
} __attribute__((packed)) netiface, *pnetiface;

typedef struct _tagnetinfopacket {
	netheader	header;
	nethwid		hwid;
	netiface	iface;
	int8		devicespeed;
	int8		status;
	int32		handle;
	int32		ip;
	int32		pass1;
	int32		pass2;
	int32		locinf_len;
	int32		devdes_len;
	int32		nicknm_len;
	int32		instid_len;
} __attribute__((packed)) netinfopacket, *pnetinfopacket;

#pragma pack (pop)


#endif // _PUBNETPROTOCOL_
